<?php

class KT_Zoho_Listen_KT_Outbound_Event {

	function __construct() {
		add_action( 'parse_request', array( $this, "process_outbound_event" ) );

	}

	function process_outbound_event() {
		if ( ! empty( self::get( 'klicktipp-outbound' ) ) && ! empty( self::get( 'zoho-feed-id' ) ) ) {
			$zoho_feed_id = self::get( 'zoho-feed-id' );
			$subscriber_id = self::post( 'SubscriberID' );
			KT_Zoho_Logs()->log( '============ DATA RECEIVED FROM KLICK TIPP WEBHOOK ============ ' . date( 'd/M/Y' ) . ' ============ ' );
			KT_Zoho_Logs()->log( 'SubscriberID => ' . $subscriber_id . PHP_EOL );

			if ( ! empty( $subscriber_id ) && ! empty( $zoho_feed_id ) ) {
				$connection = kt_zoho_connect_api();

				if ( ! isset( $connection['success'] ) ) {
					$error = $connection['error'];
				} else {
					$connector = $connection['success'];
					$subscriber = $connector->subscriber_get( $subscriber_id );
					//print_r($subscriber); die;
					$zoho_module_api_name = get_post_meta( $zoho_feed_id, 'zoho_module_api_name', true );
					$kt_zoho_field_mapping = get_post_meta(  $zoho_feed_id, 'kt_zoho_field_mapping', true );
					KT_Zoho_Logs()->log( '============ Getting data from Feed ID : ' . $zoho_feed_id . ' ============ ' . PHP_EOL );


					if ( ! empty( $zoho_module_api_name ) &&  ! empty( $kt_zoho_field_mapping ) ) {
						$module_fields = KT_Zoho_Api()->get_module_fields( $zoho_module_api_name );
						$custom_fields = array();
						//print_r($module_fields); die;
						foreach ( $kt_zoho_field_mapping as $zoho_field_api_name=>$kt_field_id ) {
							if ( ! empty( $kt_field_id ) ) {
								if ( $kt_field_id === 'subscriber_id' ) {
									$custom_fields[$zoho_field_api_name] = $subscriber_id;
								} else {
									if ( $module_fields[$zoho_field_api_name]['type'] === 'boolean' ) {
										$custom_fields[$zoho_field_api_name] = filter_var( $subscriber->{$kt_field_id}, FILTER_VALIDATE_BOOLEAN );
									}else if ( $module_fields[$zoho_field_api_name]['type'] === 'multiselectpicklist' ) {
										$custom_fields[$zoho_field_api_name] = array( $subscriber->{$kt_field_id} );
									//}else if ( stripos( $zoho_field_api_name, 'DatumZeit' ) !== false ) {
									/*---------------------DateTime----------------------------------*/
									}else if ( $module_fields[$zoho_field_api_name]['type'] === 'datetime' ) {
										if( empty($subscriber->{$kt_field_id} )){
											$custom_fields[$zoho_field_api_name] ='';
										}else{
											$date_timestamp = date( 'Y-m-d H:i',  (int)$subscriber->{$kt_field_id} );
											$date = new DateTime( $date_timestamp, new DateTimeZone( 'UTC' ) ); // KT's timezone
											$date->setTimezone( new DateTimeZone( 'Europe/Berlin' ) );
											$custom_fields[$zoho_field_api_name] = $date->format(DateTime::ATOM);
										}

									//}else if ( stripos( $zoho_field_api_name, 'datum' ) !== false ) {
									/*---------------------Date----------------------------------*/
									}else if ( $module_fields[$zoho_field_api_name]['type'] === 'date' ) {
										if( empty($subscriber->{$kt_field_id} )){
											$custom_fields[$zoho_field_api_name] ='';
										}else{
											$date_timestamp = date( 'Y-m-d H:i',  (int)$subscriber->{$kt_field_id} );
											$date = new DateTime( $date_timestamp, new DateTimeZone( 'UTC' ) ); // KT's timezone
											$date->setTimezone( new DateTimeZone( 'Europe/Berlin' ) );
											$custom_fields[$zoho_field_api_name] = $date->format( 'Y-m-d' );
										}
									}else {
										$custom_fields[$zoho_field_api_name] = $subscriber->{$kt_field_id};
									}
								}

							}
						}
						// $owner = get_post_meta( $zoho_feed_id, 'owner', true );
						// if ( ! empty( $owner ) ) {
						// 	$custom_fields['Owner'] =  $owner ;
						// }

						KT_Zoho_Logs()->log( '============ FILEDS SENT TO ZOHO Object: ' . $zoho_module_api_name . PHP_EOL );
						KT_Zoho_Logs()->log( print_r( $custom_fields, TRUE  ) );
						//var_dump( $custom_fields ); die;
						if ( $custom_fields ) {
							$wftrigger = get_post_meta( $zoho_feed_id, 'wftrigger', true );
							$send_empty_fields = get_post_meta( $zoho_feed_id, 'send_empty_fields', true );
							$duplicate_leads = get_post_meta( $zoho_feed_id, 'duplicate_leads', true );

							$trigger = array();
							if ( $wftrigger ) {
								$trigger = array( 'workflow' );
							}

							if( ! $send_empty_fields ){
								$custom_fields = array_filter($custom_fields);
							}

							$query = "SELECT First_Name FROM " . $zoho_module_api_name . " WHERE Email = '" . $custom_fields['Email'] . "'";
							$response = KT_Zoho_Api()->make_request( 'POST', '/crm/v2/coql', array( 'select_query'=> $query ) );

							if ( ! empty( $response ) && isset( $response['data'] ) && empty( $duplicate_leads ) ) {
								foreach ( $response['data'] as $object ) {
									$id = $object['id'];
									$response = KT_Zoho_Api()->make_request( 'PUT', '/crm/v2/' . $zoho_module_api_name . '/' . $id , array( 'data'=> array( $custom_fields ), 'trigger'=>$trigger ) );
								}
							} else {
								// send data to zoho
								$response = KT_Zoho_Api()->make_request( 'POST', '/crm/v2/' . $zoho_module_api_name, array( 'data'=> array( $custom_fields ), 'trigger'=>$trigger ) );
							}

							// var_dump($response); die;
							KT_Zoho_Logs()->log( '============ RESPONSE RECEIVED FROM ZOHO ========== ' . PHP_EOL );
							KT_Zoho_Logs()->log( print_r( $response, TRUE  ) );
							var_dump( $response ); die;
						}
					}
					$connector->logout();
				}
			}
		}
	}


	public static function get( $name, $array = null ) {
		if ( ! $array )
			$array = $_GET;

		if ( isset( $array[$name] ) )
			return $array[$name];

		return "";
	}


	public static function post( $name ) {
		if ( isset( $_POST[$name] ) )
			return $_POST[$name];

		return "";
	}

	public function get_resource_id_key( $resource ) {
		return explode( '_', $resource );
	}
}
new KT_Zoho_Listen_KT_Outbound_Event();
