<?php
class KT_Zoho_Posttype {
	function __construct() {
		add_action( 'init', array( $this, 'register_posttype' ) );
	}

	function register_posttype() {
		$labels = array(
			'name'               => _x( 'KT Zoho Integrationen', 'post type general name', 'kt-zohon' ),
			'singular_name'      => _x( 'KT Zoho Integration', 'post type singular name', 'kt-zoho' ),
			'menu_name'          => _x( 'KT Zoho Integrationen', 'admin menu', 'kt-zoho' ),
			'name_admin_bar'     => _x( 'KT Zoho Integration', 'add new on admin bar', 'kt-zoho' ),
			'add_new'            => _x( 'Erstellen', 'KT Zoho', 'kt-zoho' ),
			'add_new_item'       => __( 'KT Zoho Integration hinzufügen', 'kt-zoho' ),
			'new_item'           => __( 'New KT Zoho Integration', 'kt-zoho' ),
			'edit_item'          => __( 'KT Zoho Integration bearbeiten', 'kt-zoho' ),
			'view_item'          => __( 'View KT Zoho Integration', 'kt-zoho' ),
			'all_items'          => __( 'Alle KT Zoho Integrationen', 'kt-zoho' ),
			'search_items'       => __( 'Integrationen Suchen', 'kt-zoho' ),
			'parent_item_colon'  => __( 'Parent KT Zoho Integrationen:', 'kt-zoho' ),
			'not_found'          => __( 'No integrations found.', 'kt-zoho' ),
			'not_found_in_trash' => __( 'No integrations found in Trash.', 'kt-zoho' )
		);

		$args = array(
			'labels'             => $labels,
			'description'        => __( 'Description.', 'kt-zoho' ),
			'public'             => false,
			'publicly_queryable' => true,
			'show_ui'            => true,
			'show_in_menu'       => true,
			'query_var'          => true,
			'rewrite'            => array( 'slug' => 'kt-zoho' ),
			'capability_type'    => 'post',
			'has_archive'        => false,
			'hierarchical'       => false,
			'menu_position'      => null,
			'supports'           => array( 'title' )
		);

		register_post_type( 'kt-zoho', $args );
	}

}
new KT_Zoho_Posttype();
