<?php

class KT_Zoho_Webhook {

	function __construct() {
		add_action( 'parse_request', array( $this, "process_outbound_event" ) );
	}

	function process_outbound_event() {
		// $record = KT_Zoho_Api()->get_record( 'contacts', '3931407000000241041' );
		// echo '<pre>';
		// print_r( $record['data'][0] ); die;
		// KT_Zoho_Logs()->log( print_r( $_GET, TRUE  ) );
		// KT_Zoho_Logs()->log( print_r( $_POST, TRUE  ) );
		if ( isset( $_POST['zoho_webhook'] ) && $_POST['zoho_webhook'] == 'true' && isset( $_POST['module'] ) ) {

			$key = $_POST['module'] . '_id';
			if ( ! empty( $key ) ) {
				$record_id = $_POST[$key];
			}
			KT_Zoho_Logs()->log( '============ DATA RECEIVED FROM ZOHO WEBHOOK ============ ' . date( 'd/M/Y' ) . ' ============ ' );
			KT_Zoho_Logs()->log( print_r( $_REQUEST, TRUE  ) );

			$record = KT_Zoho_Api()->get_record( $_POST['module'], $record_id );

			KT_Zoho_Logs()->log( '============ Fetching ZOHO Record Details ======' );
			KT_Zoho_Logs()->log( '============ ZOHO Response  ============ ' .  print_r( $record, TRUE  )  . ' ============ ' );

			if ( isset( $record['data'][0] ) && is_array( $record['data'][0] ) ) {
				$zoho_record = $record['data'][0];
				KT_Zoho_Logs()->log( print_r( $zoho_record, TRUE  ) );
				$args=  array(
						'post_type'=>'kt-zoho',
						'meta_query' => array(
							'relation' => 'AND',
							array(
								'key'     => 'zoho_feed_action',
								'value'   => 'zoho_to_kt',
							),
							array(
								'key'     => 'zoho_module_api_name',
								'value'   => $_POST['module'],
							),
						),
					);

					if( isset( $_POST['feed_id']) && !empty( $_POST['feed_id'])){
					$args['p']= (int) $_POST['feed_id'];

					}

				$the_query = new WP_Query( $args );

				if ( $the_query->have_posts() ) {
					while ( $the_query->have_posts() ) {
						$the_query->the_post();

						$connection = kt_zoho_connect_api();

						if ( ! isset( $connection['success'] ) ) {
							$error =   array( $connection['error'] );
						} else {
							$connector = $connection['success'];
							$fields = array();
							$mapped_fields = get_post_meta( get_the_ID(), 'zoho_kt_field_mapping', true );
							$list_id = get_post_meta( get_the_ID(), 'optin_process', true );
							$tags = get_post_meta( get_the_ID(), 'kt_tags', true );
							if ( ! empty( $mapped_fields ) ) {

								$module_fields = KT_Zoho_Api()->get_module_fields( $_POST['module'] );

								foreach ( $mapped_fields as $kt_field_id => $zoho_field_id ) {
									if ( ! empty( $kt_field_id ) ) {
										$zoho_field_value = $zoho_record[$zoho_field_id];
										if( is_array( $zoho_field_value ) ) {
											$fields[$kt_field_id] = isset( $zoho_field_value['name'] ) ? $zoho_field_value['name'] :'';
										} elseif( $module_fields[$zoho_field_id]['type'] == 'datetime'){
											$fields[$kt_field_id] = $this->convert_date( $zoho_field_value );
										} elseif ( $this->is_date( $zoho_field_value ) ) {
											$fields[$kt_field_id] = $this->convert_date( $zoho_field_value );
										} else{
											$fields[$kt_field_id] = $zoho_field_value;
										}
										// check if mapped KT field id is email or smsnumber
										if ( $kt_field_id == 'email' ) {
											$email_id = $fields[$kt_field_id];
											unset( $fields[$kt_field_id] );
										} elseif ( $kt_field_id == 'smsnumber' ) {
											$smsnumber = $fields[$kt_field_id];
											unset( $fields[$kt_field_id] );
										}
									}
								}
								//KT_Acuity_Logs()->log( '============= DATA RECEIVED FOR APPOINTMENT ID : ' . $payload['id']  . ' === ' . date( 'd/M/Y' ) . ' ============= ' );
								KT_Zoho_Logs()->log( PHP_EOL . '============ DATA SENT TO KLICK TIPP ============ ' );
								KT_Zoho_Logs()->log( 'List ID => ' . $list_id . PHP_EOL . 'Email ID => ' . $email_id . PHP_EOL .  'SMS Number => ' . $smsnumber . PHP_EOL . 'Tags => ' .  print_r( $tags, TRUE  ) . PHP_EOL . 'Mapped Fields => ' . print_r( $fields, TRUE  ) );
								// print_r($tags);
								//  print_r( $appointment );
								//die;
								if ( ! empty( $fields ) ) {
									$send_empty_fields = get_post_meta( get_the_ID(), 'send_empty_fields', true );
									if( ! $send_empty_fields ){
										$fields = array_filter($fields);
									}
								//	$subscriber_id = $connector->subscriber_search( $zoho_record['Email'] );
								//	if ( $subscriber_id ) {
										// echo $smsnumber;
								//		$subscriber = $connector->subscriber_update( $subscriber_id, $fields, '', $smsnumber );
								//	} else {
										//create a new user
										$subscriber = $connector->subscribe( $email_id, $list_id, '', $fields, $smsnumber );
								//	}

									//var_dump($subscriber);
									if ( $subscriber ) {
										//var_dump($subscriber);
										KT_Zoho_Logs()->log(  'Klick Tipp response: Success --- Subscriber successfully created/updated.' . PHP_EOL . PHP_EOL  );
										//print 'Subscriber successfully updated.';
									} else {
										KT_Zoho_Logs()->log(  'Klick Tipp response: Error --- ' . $connector->get_last_error() . PHP_EOL . PHP_EOL  );
										//print $connector->get_last_error();

									}
									//  print_r($tags);
									//  print_r($appointment);

									if ( ! empty( $tags ) ) {
										$connector->tag( $zoho_record['Email'], $tags );
									}
									//print_r( $fields ); die;
								}
							}

							$connector->logout();
						}
					}
				}
			}
		}
	}


	public static function get( $name, $array = null ) {
		if ( ! $array )
			$array = $_GET;

		if ( isset( $array[$name] ) )
			return $array[$name];

		return "";
	}


	public static function post( $name ) {
		if ( isset( $_POST[$name] ) )
			return $_POST[$name];

		return "";
	}

	public static function convert_date( $zoho_date ) {
		$date = new DateTime( $zoho_date, new DateTimeZone( 'Europe/Berlin' ) ); // KT's expected timezone
		$date->setTimezone( new DateTimeZone( 'UTC' ) );
		$value = $date->format( "U" );
		return $value;
	}

	function is_date( $date, $format = 'Y-m-d' ) {
		$d = DateTime::createFromFormat( $format, $date );
		// The Y ( 4 digits year ) returns TRUE for any integer with any number of digits so changing the comparison from == to === fixes the issue.
		return $d && $d->format( $format ) === $date;
	}


}
new KT_Zoho_Webhook();
