(function ($) {
	$(document).ready(function () {
		$(".kt-select").selectWoo({
			minimumResultsForSearch: 5,
		});
		$(".kt-select-multiple").selectWoo({
			minimumResultsForSearch: 5,
		});

		$("body").on("change", ".zoho_feed_action", function () {
			var feed_action = $(this).val();
			$(".zoho_module_api_name ").val("");
			if (feed_action == "kt_to_zoho") {
				$(".zoho_to_kt_field").hide();
				$(".kt_to_zoho_field").show();
				$(".kt-to-zoho-map-fields-block").html("");
			} else {
				$(".kt_to_zoho_field").hide();
				$(".zoho_to_kt_field").show();
				$(".zoho-to-kt-map-fields-block").html("");
			}
			setup_webhook_variable_names();
		});

		$("body").on("change", ".zoho_module_api_name ", function (el) {
			var feed_action = $(".zoho_feed_action").val();
			var map_fields_block =
				feed_action == "kt_to_zoho"
					? ".kt-to-zoho-map-fields-block"
					: ".zoho-to-kt-map-fields-block";
			var module_api_name = $(this).val();
			if (module_api_name == "") {
				$(map_fields_block).html("");
				return;
			}

			// Setup Webhook Variables names
			setup_webhook_variable_names();

			$(map_fields_block).html(
				'<span class="spinner kt-zoho-fields-spinner"></span>'
			);
			var data = {
				action: "kt_zoho_get_mapping_fields",
				module_api_name: module_api_name,
				feed_action: feed_action,
			};
			$.post(ajaxurl, data, function (response) {
				$(map_fields_block).html(response);
				$(".kt-select").selectWoo({
					minimumResultsForSearch: 5,
				});
				$(".kt-select-multiple").selectWoo({
					minimumResultsForSearch: 5,
				});
			});
		});

		$("body").on("click", ".kt_zoho_clear_field_cache", function (el) {
			el.preventDefault();
			var data = {
				action: "kt_zoho_clear_field_cache",
			};
			$.post(ajaxurl, data, function (response) {
				alert(
					"Cache cleared sucessfully. Reloading page please wait...."
				);
				location.reload();
			});
		});

		init_field_layout_display();
		setup_webhook_variable_names();
	});

	function init_field_layout_display() {
		var feed_action = $(".zoho_feed_action").val();

		if (feed_action == "kt_to_zoho") {
			$(".zoho_to_kt_field").hide();
			$(".kt_to_zoho_field").show();
		} else {
			$(".kt_to_zoho_field").hide();
			$(".zoho_to_kt_field").show();
		}
	}

	function setup_webhook_variable_names() {
		var post_ID = $("#post_ID").val();
		var feed_action = $(".zoho_feed_action").val();
		var module_api_name = $(".zoho_module_api_name").val();
		if (feed_action == "zoho_to_kt") {
			var var_text =
				"<strong>Parameter Name: </strong>" +
				module_api_name +
				"_id<br/><strong>Custom Parameter: </strong> module=" +
				module_api_name +
				", zoho_webhook=true, feed_id=" +
				post_ID;
			$(".webhook-variable-names").html(var_text);
			$(".webhook-variable-names-cont").show();
		} else {
			$(".webhook-variable-names-cont").hide();
		}
	}
})(jQuery);
