<?php
/*
Plugin Name: Klick Tipp Zoho Integration
Description: Integrieren Sie Klick-Tipp mit Zoho.
Author: KlickTipp-Solutions.de
Author URI: https://www.klicktipp-solutions.de
Plugin URI: https://www.klicktipp-solutions.de/
Version: 1.2.4.6
*/
define( "KT_ZOHO_PLUGIN_URL", plugins_url() . "/" . basename( dirname( __FILE__ ) ) );
define( "KT_ZOHO_PLUGIN_DIR", WP_PLUGIN_DIR . "/" . basename( dirname( __FILE__ ) ) );

define( 'KT_ZOHO_OAUTH2_REVOKE_URI', 'https://accounts.zoho.com/oauth/v2/token/revoke' );
define( 'KT_ZOHO_OAUTH2_TOKEN_URI', 'https://accounts.zoho.com/oauth/v2/token' );
define( 'KT_ZOHO_OAUTH2_AUTH_URL', 'https://accounts.zoho.com/oauth/v2/auth' );

define( 'KT_ZOHO_STORE_URL', 'https://www.klicktipp-solutions.de' );
define( 'KT_ZOHO_ITEM_ID', '7497' );
define( 'KT_ZOHO_VERSION',  '1.2.4.6' );
define( 'KT_ZOHO_PLUGIN_FILE', __FILE__ );
if ( ! class_exists( 'EDD_SL_Plugin_Updater' ) ) {
	// load our custom updater
	include dirname( __FILE__ ) . '/updater/EDD_SL_Plugin_Updater.php';
}
include_once 'updater/license.php';

require_once KT_ZOHO_PLUGIN_DIR . '/inc/class-kt-zoho-posttype.php';
if ( ! class_exists( 'KlicktippConnector' ) ) {
	require_once KT_ZOHO_PLUGIN_DIR . '/inc/lib/klicktipp.api.inc';
}
require_once KT_ZOHO_PLUGIN_DIR . '/inc/class-kt-zoho-auth.php';
require_once KT_ZOHO_PLUGIN_DIR . '/inc/class-kt-zoho-api.php';
require_once KT_ZOHO_PLUGIN_DIR . '/inc/class-kt-zoho-settings.php';
require_once KT_ZOHO_PLUGIN_DIR . '/inc/class-kt-zoho-logs.php';
require_once KT_ZOHO_PLUGIN_DIR . '/inc/class-kt-zoho-webhook.php';
require_once KT_ZOHO_PLUGIN_DIR . '/inc/class-kt-zoho-listen-kt-outbound-event.php';

//zoho
require_once KT_ZOHO_PLUGIN_DIR . '/inc/class-kt-zoho-helper.php';
require_once KT_ZOHO_PLUGIN_DIR . '/inc/class-kt-zoho-field-mapping.php';



function kt_zoho_connect_api() {
	$settings = get_option( 'kt_zoho_settings' );

	if ( ! empty( $settings['kt_username'] ) && ! empty( $settings['kt_password'] ) ) {
		$connector = new KlicktippConnector();
		$logged_in = $connector->login( $settings['kt_username'], $settings['kt_password'] );
		if ( ! $logged_in ) {
			return array( 'error'=>$connector->get_last_error() );
		} else {
			return array( 'success' => $connector );
		}
	} else {
		return array( 'error'=>'Wrong Klick Tipp details.' );
	}
}
